<?php
/*************************************************************************
 * XenForo RM Donations - Xen Factory (c) 2015-2019
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\ControllerPlugin;

use XF\ControllerPlugin\AbstractPlugin;
use XFRM\Entity\ResourceItem;

class ResourceImage extends AbstractPlugin
{
    public function actionUpload(ResourceItem $resource)
    {
        /** @var \XFA\RMMarketplace\Service\ResourceItem\Image $imageService */
        $imageService = $this->service('XFA\RMMarketplace:ResourceItem\Image', $resource);

        $action = $this->filter('image_action', 'str');

        if ($action == 'delete')
        {
            $imageService->deleteImage();
        }
        else if ($action == 'custom')
        {
            $upload = $this->request->getFile('image_upload', false, false);
            if ($upload)
            {
                if (!$imageService->setImageFromUpload($upload))
                {
                    throw $this->exception($this->error($imageService->getError()));
                }

                if (!$imageService->updateImage())
                {
                    throw $this->exception($this->error(\XF::phrase('xfa_new_image_could_not_be_applied_try_later')));
                }
            }
        }
    }
}