<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Cron;

class CleanUp
{
    public static function runDailyCleanUp()
    {
        $app = \XF::app();

        if (\XF::options()->xfa_rmmp_unpaidPruneDelay > 0)
        {
            /** @var \XFA\RMMarketplace\Repository\Purchase $purchaseRepo */
            $purchaseRepo = $app->repository('XFA\RMMarketplace:Purchase');
            $purchaseRepo->pruneUnpaidPurchases();
        }

        /** @var \XFA\RMMarketplace\Repository\FeaturingPurchase $featuringPurchaseRepo */
        $featuringPurchaseRepo = $app->repository('XFA\RMMarketplace:FeaturingPurchase');
        $featuringPurchaseRepo->pruneUnpaidPurchases();
    }

    public static function runFeatureExpire()
    {
        $app = \XF::app();

        /** @var \XFA\RMMarketplace\Repository\FeaturingPurchase $featuringPurchaseRepo */
        $featuringPurchaseRepo = $app->repository('XFA\RMMarketplace:FeaturingPurchase');
        $featuringPurchaseRepo->expirePurchasedFeaturing();
    }

    public static function runDiscountUpdate()
    {
        $app = \XF::app();

        /** @var \XFA\RMMarketplace\Repository\Discount $discountRepo */
        $discountRepo = $app->repository('XFA\RMMarketplace:Discount');
        $discountRepo->expireDiscounts();
        $discountRepo->applyDiscounts();
    }
}