<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2023
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class CouponUsage extends Entity
{
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_xfa_rmmp_coupon_usage';
        $structure->shortName = 'XFA\RMMarketplace:CouponUsage';
        $structure->primaryKey = 'usage_id';
        $structure->columns = [
            'usage_id'      => ['type' => self::UINT, 'autoIncrement' => true, 'nullable' => true],
            'coupon_id'     => ['type' => self::UINT, 'required' => true],
            'purchase_id'   => ['type' => self::UINT, 'required' => true],
            'user_id'       => ['type' => self::UINT, 'required' => true]
        ];
        $structure->getters = [];
        $structure->relations = [
            'Coupon' => [
                'entity'        => 'XFA\RMMarketplace:Coupon',
                'type'          => self::TO_ONE,
                'conditions'    => 'coupon_id'
            ],
            'Purchase' => [
                'entity'        => 'XFA\RMMarketplace:Purchase',
                'type'          => self::TO_ONE,
                'conditions'    => 'purchase_id'
            ]
        ];

        return $structure;
    }
}