<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class FeaturingDuration extends Entity
{
    public function getTypePhrase()
    {
        return \XF::phrase($this->type);
    }

    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_xfa_rmmp_featuring_duration';
        $structure->shortName = 'XFA\RMMarketplace:FeaturingDuration';
        $structure->primaryKey = 'duration_id';
        $structure->columns = [
            'duration_id'   => ['type' => self::UINT, 'autoIncrement' => true, 'nullable' => true],
            'value'         => ['type' => self::UINT, 'required' => true],
            'type'          => ['type' => self::STR, 'required' => true],
            'amount'        => ['type' => self::FLOAT, 'default' => 0, 'max' => 99999999, 'min' => 0],
            'active'        => ['type' => self::BOOL, 'default' => true],
            'display_order' => ['type' => self::UINT, 'default' => 0]
        ];
        $structure->getters = [];
        $structure->relations = [];
        $structure->defaultWith = [];

        return $structure;
    }
}