<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class PhysicalProduct extends Entity
{
    public function isPurchasable()
    {
        if ($this->quantity == 0 && !$this->sell_on_stockout)
        {
            return false;
        }
        else
        {
            return true;
        }
    }

    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_xfa_rmmp_physical_product';
        $structure->shortName = 'XFA\RMMarketplace:PhysicalProduct';
        $structure->primaryKey = 'physicalp_id';
        $structure->columns = [
            'physicalp_id'      => ['type' => self::UINT, 'autoIncrement' => true, 'nullable' => true],
            'resource_id'       => ['type' => self::UINT, 'required' => true],
            'quantity'          => ['type' => self::UINT, 'required' => true],
            'sell_on_stockout'  => ['type' => self::BOOL, 'required' => true],
            'shipping'			=> ['type' => Entity::JSON_ARRAY, 'default' => '']
        ];
        $structure->getters = [];
        $structure->relations = [];

        return $structure;
    }
}