<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class PurchaseInfo extends Entity
{
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_xfa_rmmp_purchase_add_info';
        $structure->shortName = 'XFA\RMMarketplace:PurchaseInfo';
        $structure->primaryKey = 'purchase_id';
        $structure->columns = [
            'purchase_id'       => ['type' => self::UINT],
            'name'              => ['type' => self::STR, 'required' => true],
            'phone'             => ['type' => self::STR],
            'address'           => ['type' => self::STR, 'required' => true],
            'additional_info'   => ['type' => self::STR]
        ];
        $structure->getters = [];
        $structure->relations = [];

        return $structure;
    }
}