<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Job\Upgrade;

use XF\Db\Schema\Alter;
use XF\Job\AbstractRebuildJob;

class Purchase904030090 extends AbstractRebuildJob
{
    protected function getNextIds($start, $batch)
    {
        $db = $this->app->db();

        return $db->fetchAllColumn($db->limit(
            "
				SELECT purchase_id
				FROM xfa_rmmp_purchase
				WHERE purchase_id > ?
				ORDER BY purchase_id
			", $batch
        ), $start);
    }

    protected function rebuildById($id)
    {
        $purchase = \XF::finder('XFA\RMMarketplace:Purchase')->whereId($id)->fetchOne();

        // Update the purchase data
        if ($purchase->type == 'purchase')
        {
            // Set the purchase id in the license table
            $this->app->db()->update('xfa_rmmp_license', ['purchase_id' => $purchase->purchase_id], 'license_id = ?', $purchase->license_id);

            // Reset license id for the purchase
            $purchase->fastUpdate('license_id', 0);
        }
    }

    protected function getStatusType()
    {
        return \XF::phrase('xfa_rmmp_purchases_data');
    }
}