<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Job\Upgrade;

use XF\Job\AbstractRebuildJob;

class Resource904030290 extends AbstractRebuildJob
{
    protected function getNextIds($start, $batch)
    {
        $db = $this->app->db();

        return $db->fetchAllColumn($db->limit(
            "
				SELECT resource_id
				FROM xf_rm_resource
				WHERE resource_id > ?
				ORDER BY resource_id
			", $batch
        ), $start);
    }

    protected function rebuildById($id)
    {
        $purchasesData = $this->app->db()->query('
            SELECT COALESCE(SUM(quantity),0) AS total_quantity
            FROM xfa_rmmp_purchase
            WHERE resource_id = ?
        ', $id)->fetch();

        // Update user
        if ($purchasesData && $purchasesData['total_quantity'])
        {
            $this->app->db()->update('xf_rm_resource', ['xfa_rmmp_purchases' => $purchasesData['total_quantity']], 'resource_id = ?', $id);
        }
    }

    protected function getStatusType()
    {
        return \XF::phrase('xfa_rmmp_purchases_count');
    }
}