<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Job\Upgrade;

use XF\Job\AbstractRebuildJob;

class Resource905010100 extends AbstractRebuildJob
{
    protected function getNextIds($start, $batch)
    {
        $db = $this->app->db();

        return $db->fetchAllColumn($db->limit(
            "
				SELECT resource_id
				FROM xf_rm_resource
				WHERE resource_id > ? AND xfa_rmmp_discount_id = 0
				ORDER BY resource_id
			", $batch
        ), $start);
    }

    protected function rebuildById($id)
    {
        $resource = $this->app->finder('XFRM:ResourceItem')->whereId($id)->fetchOne();
        $resource->fastUpdate('xfa_rmmp_base_amount', $resource->xfa_rmmp_amount);
    }

    protected function getStatusType()
    {
        return \XF::phrase('resources');
    }
}