<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Job\Upgrade;

use XF\Db\Schema\Alter;
use XF\Job\AbstractRebuildJob;

class User904030090 extends AbstractRebuildJob
{
    protected function getNextIds($start, $batch)
    {
        $db = $this->app->db();

        return $db->fetchAllColumn($db->limit(
            "
				SELECT user_id
				FROM xf_user
				WHERE user_id > ?
				ORDER BY user_id
			", $batch
        ), $start);
    }

    protected function rebuildById($id)
    {
        // Get User
        $user = \XF::finder('XF:User')->whereId($id)->fetchOne();

        // Get User sales data
        $salesData = $this->app->db()->query('
            SELECT COUNT(purchase.purchase_id) AS sales, SUM(purchase.price) AS sales_amount
            FROM xfa_rmmp_purchase AS purchase
            LEFT JOIN xf_rm_resource AS resource ON (resource.resource_id=purchase.resource_id)
            WHERE resource.user_id = ?
        ', $user->user_id)->fetch();

        // Update user
        if ($salesData['sales'])
        {
            $this->app->db()->update('xf_user', ['xfa_rmmp_user_sales' => $salesData['sales'], 'xfa_rmmp_user_sales_amount' => $salesData['sales_amount']], 'user_id=' . $user->user_id);
        }
    }

    protected function getStatusType()
    {
        return \XF::phrase('xfa_rmmp_user_sales_data');
    }
}