<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Option;

class ResourceCurrency extends \XF\Option\AbstractOption
{
    public static function renderRadio(\XF\Entity\Option $option, array $htmlParams)
    {
        $data = self::getRadioData($option, $htmlParams);

        return self::getTemplater()->formRadioRow(
            $data['controlOptions'], $data['choices'], $data['rowOptions']
        );
    }

    protected static function getRadioData(\XF\Entity\Option $option, array $htmlParams)
    {
        /** @var \XFRM\Repository\ResourceItem $resourceRepo */
        $resourceRepo = \XF::repository('XFRM:ResourceItem');

        $choices = $resourceRepo->getAvailableCurrencies();

        $choices = array_map(function($v) {
            $v['_type'] = 'option';
            $v['label'] = strtoupper($v['code']);
            $v['value'] = strtoupper( $v['code']);
            return $v;
        }, $choices);

        return [
            'choices'           => $choices,
            'controlOptions'    => self::getControlOptions($option, $htmlParams),
            'rowOptions'        => self::getRowOptions($option, $htmlParams)
        ];
    }
}