<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2022
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Pub\View;

use XF\Mvc\View;

class GetDiscountResources extends View
{
    public function renderJson()
    {
        $results = [];

        /** @var \XFRM\Entity\ResourceItem $resource */
        foreach ($this->params['resources'] AS $resource)
        {
            $results[] = [
                'id'        => $resource->resource_id,
                'iconHtml'  => $this->renderer->getTemplater()->fn('resource_icon', [$resource, 'xxs']),
                'text'      => $resource->title,
                'q'         => $this->params['q']
            ];
        }

        return [
            'results'   => $results,
            'q'         => $this->params['q']
        ];
    }
}
