<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2022
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Repository;

use XF\Mvc\Entity\Finder;
use XF\Mvc\Entity\Repository;
use XF\PrintableException;

class Discount extends Repository
{
    public function expireDiscounts()
    {
        $discountFinder = $this->finder('XFA\RMMarketplace:Discount')
            ->where('to_date', '<', \XF::$time)
            ->where('applied', '=', 1);

        $discounts = $discountFinder->fetch();

        if ($discounts->count())
        {
            $discountIds = $discounts->keys();

            $discountApplierParams = [
                'discount_ids'  => $discountIds,
                'discount_id'   => current($discountIds)
            ];

            \XF::app()->jobManager()->enqueue('XFA\RMMarketplace:DiscountsRemover', $discountApplierParams);
        }
    }

    public function applyDiscounts()
    {
        $discountFinder = $this->finder('XFA\RMMarketplace:Discount')
            ->where('from_date', '<=', \XF::$time)
            ->where('to_date', '>', \XF::$time)
            ->where('applied', '=', 0);

        $discounts = $discountFinder->fetch();

        if ($discounts->count())
        {
            $discountIds = $discounts->keys();

            $discountApplierParams = [
                'discount_ids'  => $discountIds,
                'discount_id'   => current($discountIds)
            ];

            \XF::app()->jobManager()->enqueue('XFA\RMMarketplace:DiscountsApplier', $discountApplierParams);
        }
    }
}