<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Repository;

use XF\Mvc\Entity\Finder;
use XF\Mvc\Entity\Repository;
use XF\PrintableException;

class License extends Repository
{
    public function warnLicenseExpiration()
    {
        /** @var \XFA\RMMarketplace\Finder\License $licenseFinder */
        $licenseFinder = $this->finder('XFA\RMMarketplace:License');
        $licenseFinder->where('validated', '=', 1);
        $licenseFinder->where('active', '=', 1);
        $licenseFinder->where('end_date', '>', 0);
        $licenseFinder->where('end_date', '<', \XF::$time);
        $licenseFinder->where('expiration_sent', '=', 0);
        $licenseFinder->with(['Resource', 'Holder'], true);
        $licenses = $licenseFinder->fetch();

        foreach($licenses AS $license)
        {
            $expirationNotifier = \XF::service('XFA\RMMarketplace:License\NotifyExpiration', $license);
            $expirationNotifier->notify();
        }
    }
}