<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Repository;

use XF\Mvc\Entity\Finder;
use XF\Mvc\Entity\Repository;
use XF\PrintableException;

class MonthlyInvoice extends Repository
{
    public function findInvoicesForList()
    {
        return $this->finder('XFA\RMMarketplace:MonthlyInvoice')
            ->with(['Seller'])
            ->setDefaultOrder('invoice_date', 'DESC');
    }

    public function getUsersWithInvoices()
    {
        return $this->db()->fetchPairs("
			SELECT user.user_id, user.username
			FROM (
				SELECT DISTINCT user_id FROM xf_xfa_rmmp_invoices
			) AS invoice
			INNER JOIN xf_user AS user ON (invoice.user_id = user.user_id)
			ORDER BY user.username
		");
    }
}