<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Service\FeaturingPurchase;

use XFA\RMMarketplace\Entity\FeaturingPurchase;

class Expire extends \XF\Service\AbstractService
{
    /**
     * @var FeaturingPurchase
     */
    protected $purchase;

    public function __construct(\XF\App $app, FeaturingPurchase $purchase)
    {
        parent::__construct($app);

        $this->purchase = $purchase;
    }

    public function expire()
    {
        $db = $this->db();
        $db->beginTransaction();

        $purchase = $this->purchase;
        $resource = $purchase->Resource;

        /* Validate the purchase */
        $purchase->status           = 'expired';
        $purchase->validation_date  = \XF::$time;
        $purchase->save();

        /* Feature resource */
        /** @var \XFRM\Service\ResourceItem\Feature $featurer */
        $featurer = $this->service('XFRM:ResourceItem\Feature', $resource);
        $featurer->unfeature();

        /* Notify buyer */
        /** @var \XFA\RMMarketplace\Service\FeaturingPurchase\Notify $notifier */
        $notifier = $this->service('XFA\RMMarketplace:FeaturingPurchase\Notify', $purchase);

        /* Email the purchaser */
        $notifier->emailBuyer('xfa_rmmp_purchase_featuring_expired');

        $db->commit();
    }
}