<?php
/*************************************************************************
 * XFA Core - Xen Factory (c) 2017
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Service\FeaturingPurchase;

use XFA\RMMarketplace\Entity\FeaturingPurchase;

class Notify extends \XF\Service\AbstractService
{
    /**
     * @var FeaturingPurchase
     */
    protected $purchase;

    public function __construct(\XF\App $app, FeaturingPurchase $purchase)
    {
        parent::__construct($app);

        $this->purchase = $purchase;
    }

    public function emailBuyer($mailTemplate, $params = [])
    {
        $params['purchase'] = $this->purchase;

        $this->app->mailer()->newMail()
            ->setToUser($this->purchase->Buyer)
            ->setTemplate($mailTemplate, $params)
            ->queue();
    }

    public function alertSeller($alertType)
    {
        /** @var \XF\Repository\UserAlert $alertRepo */
        $alertRepo = $this->repository('XF:UserAlert');

        $alertRepo->alert(
            $this->purchase->Resource->User,
            $this->purchase->Buyer->user_id,
            $this->purchase->Buyer->username,
            'xfa_rmmp',
            $this->purchase->resource_id,
            $alertType
        );
    }
}