<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Service\License;

use XFA\RMMarketplace\Entity\License;

class Activate extends \XF\Service\AbstractService
{
    /**
     * @var License
     */
    protected $license;

    public function __construct(\XF\App $app, License $license)
    {
        parent::__construct($app);

        $this->license = $license;
    }

    public function activate()
    {
        $license = $this->license;

        /* If required change usergroup */
        if (\XF::options()->xfa_rmmp_usergroup_onbuy)
        {
            $db = $this->db();
            $db->beginTransaction();

            /** @var \XF\Service\User\TempChange $userGroupChange */
            $userGroupChange = $this->service('XF:User\TempChange');
            $userGroupChange->applyGroupChange(
                $license->Holder,
                'xfa_rmmp_license_' . $license->license_id,
                [\XF::options()->xfa_rmmp_usergroup_onbuy],
                null,
                $license->end_date
            );

            /** @var \XF\Repository\UserAlert $alertRepo */
            $alertRepo = $this->repository('XF:UserAlert');
            $alertRepo->fastDeleteAlertsFromUser(
                $license->Holder->user_id,
                'user',
                $license->Holder->user_id,
                'upgrade_end'
            );

            $db->commit();
        }

        /* Validate the license */
        $license->validated = 1;
        $license->active    = 1;
        $license->save();
    }
}