<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Service\License;

use XFA\RMMarketplace\Entity\License;

class Edit extends \XF\Service\AbstractService
{
    use \XF\Service\ValidateAndSavableTrait;

    /**
     * @var License
     */
    protected $license;

    public function __construct(\XF\App $app, License $license)
    {
        parent::__construct($app);

        $this->license = $license;
    }

    public function setActivationStatus($active)
    {
        $this->license->active = $active;
    }

    public function setSiteUrl($siteUrl)
    {
        $this->license->siteurl = $siteUrl;
    }

    public function setEndDate($endDate)
    {
        $this->license->end_date = $endDate;
    }

    protected function _validate()
    {
        return [];
    }

    protected function _save()
    {
        $license = $this->license;

        $license->save();

        return $license;
    }
}