<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2022
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Service\PosInvoice;

use XFA\RMMarketplace\Entity\MonthlyInvoice;

class BlockUnpaid extends \XF\Service\AbstractService
{
    /**
     * @var MonthlyInvoice $invoice
     */
    protected $invoice;

    public function __construct(\XF\App $app, MonthlyInvoice $invoice)
    {
        parent::__construct($app);

        $this->invoice = $invoice;
    }

    public function block()
    {
	    $invoice = $this->invoice;

	    // Block seller
        $invoice->Seller->fastUpdate('xfa_rmmp_user_blocked', 1);

	    // Notify seller     
        /** @var \XFA\RMMarketplace\Service\PosInvoice\Notify $notifier */
        $notifier = \XF::service('XFA\RMMarketplace:PosInvoice\Notify', $invoice);

        $notifier->emailSeller('xfa_rmmp_block_unpaid_invoice');

        $notifier->alertSeller('xfa_rmmp_block_unpaid_invoice');

        // Flag invoice
        $invoice->fastUpdate('warned', 1);
    }
}