<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Service\Purchase;

use XFA\RMMarketplace\Entity\PurchaseInfo;

class CreateInfo extends \XF\Service\AbstractService
{
    use \XF\Service\ValidateAndSavableTrait;

    /**
     * @var \XFA\RMMarketplace\Entity\Purchase $purchase
     */
    protected $purchase;

    /**
     * @var PurchaseInfo
     */
    protected $purchaseInfo;

    public function __construct(\XF\App $app, \XFA\RMMarketplace\Entity\Purchase $purchase)
    {
        parent::__construct($app);

        $this->purchase     = $purchase;
        $this->purchaseInfo = $this->em()->create('XFA\RMMarketplace:PurchaseInfo');

        $this->setPurchaseInfoDefaults();
    }

    public function getPurchaseInfo()
    {
        return $this->purchaseInfo;
    }

    protected function setPurchaseInfoDefaults()
    {
        $this->purchaseInfo->purchase_id = $this->purchase->purchase_id;
    }

    public function setName($name)
    {
        $this->purchaseInfo->name = $name;
    }

    public function setPhone($phone)
    {
        $this->purchaseInfo->phone = $phone;
    }

    public function setAddress($address)
    {
        $this->purchaseInfo->address = $address;
    }

    public function setAdditionalInfo($additionalInfo)
    {
        $this->purchaseInfo->additional_info = $additionalInfo;
    }

    protected function _validate()
    {
        return [];
    }

    protected function _save()
    {
        $purchaseInfo = $this->purchaseInfo;

        $purchaseInfo->save();

        return $purchaseInfo;
    }
}