<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\Service\Transaction;

use XFA\RMMarketplace\Entity\Transaction;

class Edit extends \XF\Service\AbstractService
{
    use \XF\Service\ValidateAndSavableTrait;

    /**
     * @var Transaction
     */
    protected $transaction;

    public function __construct(\XF\App $app, Transaction $transaction)
    {
        parent::__construct($app);

        $this->transaction = $transaction;
    }

    public function setStatus($status)
    {
        $this->transaction->status = $status;
    }

    public function setTxnId($txnId)
    {
        $this->transaction->txn_id = $txnId;
    }

    public function setFeesAmount($fees)
    {
        $this->transaction->fees = $fees;
    }

    public function setPercentageOnSaleData($txnId, $amount)
    {
        $this->transaction->txn_id_pos  = $txnId;
        $this->transaction->pos         = $amount;
    }

    protected function _validate()
    {
        return [];
    }

    protected function _save()
    {
        $transaction = $this->transaction;

        $transaction->save();

        return $transaction;
    }
}