<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\XF\Entity;

class Thread extends XFCP_Thread
{
    public function canView(&$error = null)
    {
        $canView = parent::canView($error);

        // Already can't view
        if (!$canView)
        {
            return false;
        }

        // Not a resource thread return
        if ($this->discussion_type != 'resource')
        {
            return $canView;
        }

        // Get resource
        $resource = \XF::repository('XFRM:ResourceItem')->findResourceForThread($this)->with(['Category','ValidPurchase'])->fetchOne();

        // Not linked to a resource anymore
        if (!$resource)
        {
            return true;
        }

        // Resource owner or free resource or support thread not restricted
        if ($resource->user_id == \XF::visitor()->user_id
            || $resource->xfa_rmmp_type == 'none'
            || !$resource->Category->xfa_rmmp_restrict_support)
        {
            return true;
        }

        // Has purchased product or own license
        if ($resource->xfa_rmmp_type == 'digital')
        {
            if ($resource->DigitalProduct
                && $resource->DigitalProduct->hasValidLicense())
            {
                return true;
            }
        }
        else
        {
            if ($resource->ValidPurchase)
            {
                return true;
            }
        }

        return false;
    }
    
    public function getResource()
    {
	    $with = ['Category','ValidPurchase','DigitalProduct','PhysicalProduct'];

	    return \XF::repository('XFRM:ResourceItem')->findResourceForThread($this)->with($with)->fetchOne();	    
    }
}