<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\XFRM\ControllerPlugin;

class Overview extends XFCP_Overview
{
    public function getAvailableResourceSorts()
    {
        $availableResourceSorts = parent::getAvailableResourceSorts();

        $availableResourceSorts['xfa_rmmp_purchases'] = 'xfa_rmmp_purchases';

        return $availableResourceSorts;
    }

    public function applyResourceFilters(\XFRM\Finder\ResourceItem $resourceFinder, array $filters)
    {
        parent::applyResourceFilters($resourceFinder, $filters);

        if (!empty($filters['type']))
        {
            switch ($filters['type'])
            {
                case 'free':
                    $resourceFinder->removeWhere('price', 0);
                    $resourceFinder->where([
                        ['price', 0],
                        ['xfa_rmmp_type', 'none']
                    ]);
                    break;

                case 'paid':
                    $resourceFinder->removeWhere('price', '>', 0);
                    $resourceFinder->whereOr(
                        ['price', '>', 0],
                        [['xfa_rmmp_type', '!=', 'none'], ['xfa_rmmp_amount', '>', 0]]
                    );
                    break;
            }
        }

        if (isset($filters['order']) && $filters['order'] == 'xfa_rmmp_purchases')
        {
            $resourceFinder->where('xfa_rmmp_type', '<>', 'none');
        }
    }
}