<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\XFRM\Entity;

class ResourceVersion extends XFCP_ResourceVersion
{
    public function canDownload(&$error = null)
    {
        $resource = $this->Resource;
        $visitor  = \XF::visitor();

        if (!$resource)
        {
            return false;
        }

        /* If user is author or user can download without buying download is authorized */
        if ($resource->Category->canDownloadWithoutBuying($error)
            || ($visitor->user_id && $resource->user_id == $visitor->user_id))
        {
            return true;
        }

        /* If resource is digital, check dedicated rights */
        if ($resource->xfa_rmmp_type == 'digital')
        {
            if (isset($GLOBALS['xfa_rmmp_dl_authorized']) && $GLOBALS['xfa_rmmp_dl_authorized'])
            {
                return true;
            }

            return false;
        }

        return parent::canDownload($error);
    }
}