<?php
/*************************************************************************
 * XenForo RM Marketplace - Xen Factory (c) 2015-2018
 * All Rights Reserved.
 * Created by Clement Letonnelier aka. MtoR
 *************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at http://xen-factory.com/pages/license-agreement/.
 *************************************************************************/

namespace XFA\RMMarketplace\XFRM\Pub\Controller;

use XF\Mvc\ParameterBag;

class ResourceVersion extends XFCP_ResourceVersion
{
	public function actionDownload(ParameterBag $params)
    {
        $version = $this->assertViewableVersion($params->resource_version_id);

        if ($version->Resource->xfa_rmmp_type == 'digital' && \XF::visitor()->user_id)
        {
            /** @var \XFA\RMMarketplace\Finder\License $licenseFinder */
            $licenseFinder = $this->finder('XFA\RMMarketplace:License');

            if ($version->Resource->DigitalProduct->duration)
            {
                $license = $licenseFinder->where('resource_id', $version->resource_id)
                    ->where('end_date', '>=', $version->release_date)
                    ->where('user_id', \XF::visitor()->user_id)
                    ->where('active', 1)
                    ->fetchOne();
            }
            else
            {
                $license = $licenseFinder->where('resource_id', $version->resource_id)
                    ->where('user_id', \XF::visitor()->user_id)
                    ->where('active', 1)
                    ->fetchOne();
            }

            if ($license)
            {
                /* Register capability */
                $GLOBALS['xfa_rmmp_dl_authorized'] = true;
            }
        }

        return parent::actionDownload($params);
    }
}