<html>
    
    <body>
    <?
        
    function isDomainAvailable($domain)
    {
        /* Check valid url provided */
        if(!filter_var($domain, FILTER_VALIDATE_URL))
        {
            return false;
        }
        
        /* Get Answer with CURL */
        $curlInit = curl_init($domain);
        curl_setopt($curlInit, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curlInit, CURLOPT_HEADER, true);
        curl_setopt($curlInit, CURLOPT_NOBODY, true);
        curl_setopt($curlInit, CURLOPT_RETURNTRANSFER, true);
        
        $response = curl_exec($curlInit);
        
        curl_close($curlInit);
        
        /* Return status */
        if ($response)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    function isVisitableWebsite($url)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (compatible; CrawlBot/1.0.0)');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_COOKIEJAR, $cookie);
        curl_setopt($ch, CURLOPT_HEADER, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT , 5);
        curl_setopt($ch, CURLOPT_TIMEOUT, 5);
        curl_setopt($ch, CURLOPT_ENCODING, "");
        curl_setopt($ch, CURLOPT_AUTOREFERER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);    # required for https urls
        curl_setopt($ch, CURLOPT_MAXREDIRS, 15);
        $page=curl_exec($ch);
        
        $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);

        if($httpcode>=200 && $httpcode<300)
        {
            return true;
        }
        else
        {   
            return false;
        }
    }
    
    function isVisitableWebsiteWithFollow($url)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (compatible; CrawlBot/1.0.0)');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_COOKIEJAR, $cookie);
        curl_setopt($ch, CURLOPT_HEADER, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT , 5);
        curl_setopt($ch, CURLOPT_TIMEOUT, 5);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_ENCODING, "");
        curl_setopt($ch, CURLOPT_AUTOREFERER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);    # required for https urls
        curl_setopt($ch, CURLOPT_MAXREDIRS, 15);
        $page=curl_exec($ch);
        
        $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);

        if($httpcode>=200 && $httpcode<300)
        {
            return true;
        }
        else
        {   
            return false;
        }
    }
    
    function openWithSocket($url)
    {
        ini_set("default_socket_timeout","05");
        set_time_limit(5);
        
        $f = fopen($url, "r");
        $r = fread($f,1000);
        fclose($f);
        
        if(strlen($r)>1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    $urls = array(
        'http://www.google.fr',
        'http://www.yahoo.fr',
        'http://www.xen-factory.com',
        'http://www.xenforo.com',
        'test',
        '123456'
    );
    
    ?>
    Testing different URLs, select the method that fits the best to you, it should return valid for the 4 first and invalid for the 2 others.<br />
    The curl method may not work depending on your server configuration.<br /><br />
    <?
    foreach ($urls AS $url)
    {
        echo "URL: " . $url . "<br /><br />";
        echo "Method 1 (simple curl): " . (isDomainAvailable($url) ? '<font color="green">Valid domain</font>' : '<font color="red"><b>Invalid domain</b></font>') . "<br />";
        echo "Method 2 (complex curl with visit - no follow redirect): " . (isVisitableWebsite($url) ? '<font color="green">Valid domain</font>' : '<font color="red"><b>Invalid domain</b></font>') . "<br />";
        echo "Method 3 (complex curl with visit - follow redirect): " . (isVisitableWebsiteWithFollow($url) ? '<font color="green">Valid domain</font>' : '<font color="red"><b>Invalid domain</b></font>') . "<br />";
        echo "Method 4 (file open): " . (openWithSocket($url) ? '<font color="green">Valid domain</font>' : '<font color="red"><b>Invalid domain</b></font>') . "<br />"; 
        echo "<br /><br />";
    }
?>
    </body>
</html>